import { ComponentFactoryResolver, ComponentRef, EnvironmentInjector, EventEmitter, InjectionToken, InjectOptions, Injector, OnDestroy, Type } from '@angular/core';
import { ActivatedRoute, Data, RouterOutletContract } from '@angular/router';
import { BehaviorSubject } from 'rxjs';
import * as i0 from "@angular/core";
export declare class PageRoute {
    activatedRoute: BehaviorSubject<ActivatedRoute>;
    constructor(startRoute: ActivatedRoute);
}
export declare class DestructibleInjector implements Injector {
    private destructibleProviders;
    private parent;
    private refs;
    constructor(destructibleProviders: ProviderSet, parent: Injector);
    get<T>(token: Type<T> | InjectionToken<T>, notFoundValue?: T, flags?: InjectOptions): T;
    destroy(): void;
}
type ProviderSet = Set<Type<any> | InjectionToken<any>>;
export declare class PageRouterOutlet implements OnDestroy, RouterOutletContract {
    private parentContexts;
    private location;
    private locationStrategy;
    private resolver;
    private changeDetector;
    private pageFactory;
    private routeReuseStrategy;
    private ngZone;
    private router;
    private environmentInjector;
    private activated;
    private _activatedRoute;
    private detachedLoaderFactory;
    private outlet;
    private name;
    private isEmptyOutlet;
    private viewUtil;
    private frame;
    private postNavFunction;
    attachEvents: EventEmitter<unknown>;
    detachEvents: EventEmitter<unknown>;
    activateEvents: EventEmitter<any>;
    deactivateEvents: EventEmitter<any>;
    get isActivated(): boolean;
    get component(): unknown;
    get activatedRoute(): ActivatedRoute;
    get activatedRouteData(): Data;
    constructor();
    setActionBarVisibility(actionBarVisibility: string): void;
    ngOnDestroy(): void;
    deactivate(): void;
    /**
     * Called when the `RouteReuseStrategy` instructs to detach the subtree
     */
    detach(): ComponentRef<any>;
    /**
     * Called when the `RouteReuseStrategy` instructs to re-attach a previously detached subtree
     */
    attach(ref: ComponentRef<any>, activatedRoute: ActivatedRoute): void;
    private isFinalPageRouterOutlet;
    /**
     * Called by the Router to instantiate a new component during the commit phase of a navigation.
     * This method in turn is responsible for calling the `routerOnActivate` hook of its child.
     */
    activateWith(activatedRoute: ActivatedRoute, resolver: ComponentFactoryResolver | EnvironmentInjector | null): void;
    private activateOnGoForward;
    private loadComponentInPage;
    private markActivatedRoute;
    private getComponentType;
    private getOutlet;
    static ɵfac: i0.ɵɵFactoryDeclaration<PageRouterOutlet, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<PageRouterOutlet, "page-router-outlet", never, {}, { "activateEvents": "activate"; "deactivateEvents": "deactivate"; }, never, never, true, never>;
}
export {};
